//Temp202

#define F_CPU 3333333
#define USART0_BAUD_RATE(BAUD_RATE) ((float)(F_CPU * 64 / (16 * (float)BAUD_RATE)) + 0.5)
#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>
#include <string.h>

void USART0_init(void){
	PORTA.DIRSET = 0x40;	//TXD an PA6
	PORTA.DIRCLR = 0x80;	//RXD an PA7
	USART0.BAUD = (uint16_t)USART0_BAUD_RATE(9600);
	USART0.CTRLB |= USART_TXEN_bm;
}

void USART0_sendChar(char c){
	while (!(USART0.STATUS & USART_DREIF_bm));
	USART0.TXDATAL = c;
}

void USART0_sendString(char *str){
	for(size_t i = 0; i < strlen(str); i++){
		USART0_sendChar(str[i]);
	}
}

int main(void){
  char buffer[6];
  USART0_init();
  VREF.CTRLA = VREF_ADC0REFSEL_1V1_gc;
  VREF.CTRLB =  VREF_ADC0REFEN_bm; 
  ADC0.CTRLA = ADC_ENABLE_bm | ADC_RESSEL_10BIT_gc;   
  ADC0.CTRLC = ADC_PRESC_DIV4_gc;
  ADC0.MUXPOS  = ADC_MUXPOS_TEMPSENSE_gc;
  uint16_t gain = SIGROW.TEMPSENSE0;
  uint16_t offset = SIGROW.TEMPSENSE1;
  while(1){
    ADC0.COMMAND = ADC_STCONV_bm;
    while (!(ADC0.INTFLAGS & ADC_RESRDY_bm));
    //ADC0.INTFLAGS = ADC_RESRDY_bm;
    uint16_t result = ADC0.RES  -250- offset;
    result = (result * gain) >>8;
    result += ((250 * gain) >>8); 
    result -= 273;
    itoa(result,buffer,10); 
    USART0_sendString(buffer);
    USART0_sendString("  \r\n");
    _delay_ms(2000);
  }
}