// 3DDS3216 DA0, DA1-AC1. DA2-AC2
#include <avr/io.h>
#include <avr/interrupt.h>
#include <math.h>

uint8_t dds[256]; 
uint16_t phase0=0; 
uint16_t freq0 = 4000;  //4kHz
uint16_t phase1=0; 
uint16_t freq1 = 3000;  //3kHz
uint16_t phase2=0; 
uint16_t freq2 = 2000;  //2kHz

ISR(TCA0_OVF_vect) {
    PORTA.OUT = PIN3_bm;
    DAC0.DATA = dds[phase0>>8];
    DAC1.DATA = dds[phase1>>8];
    DAC2.DATA = dds[phase2>>8];
    phase0 += freq0;
    phase1 += freq1;
    phase2 += freq2;
    PORTA.OUT = 0;
    TCA0.SINGLE.INTFLAGS = TCA_SINGLE_OVF_bm;
}

int main(void) {
     sei();
     _PROTECTED_WRITE (CLKCTRL_MCLKCTRLB, 0); // 20 MHz
     for (uint16_t n=0; n<256;n++){
          dds[n]=127+100.0*sin(3.1415*n/128.0);
     }
     PORTA.DIR |= PIN3_bm;
VREF.CTRLB = VREF_DAC0REFEN_bm|VREF_DAC1REFEN_bm|VREF_DAC2REFEN_bm; 
     VREF.CTRLA = VREF_DAC0REFSEL_2V5_gc;
     DAC0.CTRLA  = DAC_OUTEN_bm|DAC_ENABLE_bm; 
     VREF.CTRLC = VREF_DAC1REFSEL_2V5_gc;
     DAC1.CTRLA = DAC_ENABLE_bm; 
     AC1.MUXCTRLA = AC_INVERT_bm|AC_MUXNEG_DAC_gc|
AC_MUXPOS_PIN0_gc;
     AC1.CTRLA =AC_ENABLE_bm|AC_OUTEN_bm;
     VREF.CTRLD = VREF_DAC2REFSEL_2V5_gc;
     DAC2.CTRLA = DAC_ENABLE_bm; 
     AC2.MUXCTRLA = AC_INVERT_bm|AC_MUXNEG_DAC_gc|
AC_MUXPOS_PIN2_gc;
     AC2.CTRLA =AC_ENABLE_bm|AC_OUTEN_bm;
     TCA0.SINGLE.CTRLA = TCA_SINGLE_CLKSEL_DIV1_gc; 
     TCA0.SINGLE.PER = 305; //65,536 kHz 
     TCA0.SINGLE.INTCTRL = TCA_SINGLE_OVF_bm;
     TCA0.SINGLE.CTRLA |= TCA_SINGLE_ENABLE_bm;
     while (1);
}
