//DDSscope3216 

#include <avr/io.h>
#include <avr/interrupt.h>
#include <math.h>
#include <stdlib.h>
#include <util/delay.h>
#include <string.h>
#define F_CPU 20000000
#define USART0_BAUD_RATE(BAUD_RATE) ((float)(F_CPU * 64 / (16 * (float)BAUD_RATE)) + 0.5)

uint8_t dds[256]; 
uint8_t os1[510]; 
uint8_t os2[510]; 
uint16_t phase=0; 
uint16_t freq = 1000;  //1kHz
uint16_t f;  
uint16_t t = 0;
uint16_t n = 0;

void USART0_init(void){
	PORTB.DIRSET = 0x04;    //TXD an PB2
	PORTA.DIRCLR = 0x08;    //RXD an PB3
	USART0.BAUD = (uint16_t)USART0_BAUD_RATE(500000);
	USART0.CTRLB |= USART_TXEN_bm;
}

void USART0_sendChar(char c){
	while (!(USART0.STATUS & USART_DREIF_bm));
	USART0.TXDATAL = c;
}

void USART0_sendString(char *str){
	for(size_t i = 0; i < strlen(str); i++){
		USART0_sendChar(str[i]);
	}
}

ISR(TCA0_OVF_vect) {
    //PORTA.OUT = PIN3_bm;
    DAC0.DATA = dds[phase>>8];
    if (t<504){
        os1[t] = dds[phase>>8];
        os2[t]=ADC0.RES;
        ADC0.COMMAND = ADC_STCONV_bm;
        t++;
    }    
    phase += f;
    //PORTA.OUT = 0;
    TCA0.SINGLE.INTFLAGS = TCA_SINGLE_OVF_bm;
}

int main(void) {
    sei();
    _PROTECTED_WRITE (CLKCTRL_MCLKCTRLB, 0); // 20 MHz
    for (uint16_t i=0; n<256;n++){
       dds[n]=127+127.0*sin(3.1415*n/128.0);
    }
    //PORTA.DIR |= PIN3_bm;
    VREF.CTRLA = VREF_DAC0REFSEL_2V5_gc|VREF_ADC0REFSEL_2V5_gc; 
    DAC0.CTRLA  = DAC_OUTEN_bm|DAC_ENABLE_bm; 
    DAC0.DATA  = 0;             //DA an PA6
    TCA0.SINGLE.CTRLA = TCA_SINGLE_CLKSEL_DIV1_gc; 
    TCA0.SINGLE.PER = 200;      //100 kHz 
    TCA0.SINGLE.INTCTRL = TCA_SINGLE_OVF_bm;
    TCA0.SINGLE.CTRLA |= TCA_SINGLE_ENABLE_bm;
    ADC0.CTRLA = ADC_ENABLE_bm | ADC_RESSEL_8BIT_gc; 
    ADC0.CTRLC = ADC_PRESC_DIV8_gc;  //max. ADC-Takt
    ADC0.MUXPOS  = ADC_MUXPOS_AIN7_gc;  //ADC PA7
    f=int(freq/1.525);
    char buffer[6];
    USART0_init();
    while (1) {
        for (uint16_t i=3; i<503;i++){
            uint8_t result1 = os1[i];// ADC0.RES;
            uint8_t result2 = os1[i];// ADC0.RES;
            itoa( os1[i],buffer,10); 
            USART0_sendString(buffer);
            itoa( os2[i],buffer,10);
            USART0_sendChar(9); //TAB
            USART0_sendString(buffer);
            USART0_sendString("  \r\n");
        }
        _delay_ms(900);
        while (DAC0.DATA>100);
        while (DAC0.DATA<100);
        t=0;
        _delay_ms(100);
    }
}