//Scope2ch3216 
#include <avr/io.h>
#include <avr/interrupt.h>
#include <math.h>
#include <stdlib.h>
#include <util/delay.h>
#include <string.h>
#define F_CPU 20000000
#define USART0_BAUD_RATE(BAUD_RATE) ((float)(F_CPU * 64 /(16 * (float)BAUD_RATE)) + 0.5)

void USART0_init(void){
    PORTB.DIRSET = 0x04;    //TXD an PB2
    PORTA.DIRCLR = 0x08;    //RXD an PB3
    USART0.BAUD = (uint16_t)USART0_BAUD_RATE(500000);
    USART0.CTRLB |= USART_TXEN_bm;
}

void USART0_sendChar(char c){
    while (!(USART0.STATUS & USART_DREIF_bm));
    USART0.TXDATAL = c;
}

void USART0_sendString(char *str){
    for(size_t i = 0; i < strlen(str); i++){
        USART0_sendChar(str[i]);
    }
}

int main(void) {
    _PROTECTED_WRITE (CLKCTRL_MCLKCTRLB, 0); // 20 MHz
    VREF.CTRLA = VREF_ADC0REFSEL_2V5_gc; 
    ADC0.CTRLA = ADC_ENABLE_bm | ADC_RESSEL_8BIT_gc; 
    ADC0.CTRLC = ADC_PRESC_DIV8_gc;  //max. ADC-Takt
    char buffer[6];
    USART0_init();
    while (1) {
        for (uint16_t i=0; i<500;i++){
            ADC0.MUXPOS  = ADC_MUXPOS_AIN7_gc;
            ADC0.COMMAND = ADC_STCONV_bm;
            while (!(ADC0.INTFLAGS & ADC_RESRDY_bm));
            uint8_t result1 = ADC0.RES;
            ADC0.MUXPOS  = ADC_MUXPOS_AIN8_gc;
            ADC0.COMMAND = ADC_STCONV_bm;
            while (!(ADC0.INTFLAGS & ADC_RESRDY_bm));
            uint8_t result2 = ADC0.RES;
            itoa(result1,buffer,10); 
            USART0_sendString(buffer);
            itoa(result2,buffer,10);
            USART0_sendChar(9); //TAB
            USART0_sendString(buffer);
            USART0_sendString("  \r\n");
        }
        _delay_ms(1000);
    }
}
