//Sinus3216 

#include <avr/io.h>
#include <avr/interrupt.h>
#include <math.h>

uint8_t dds[256]; 
uint16_t phase=0; 
uint16_t freq = 1000;  //1kHz

ISR(TCA0_OVF_vect) {
    PORTA.OUT = PIN3_bm;
    DAC0.DATA = dds[phase>>8];
    phase += freq;
    PORTA.OUT = 0;
    TCA0.SINGLE.INTFLAGS = TCA_SINGLE_OVF_bm;
}

int main(void) {
    sei();
    _PROTECTED_WRITE (CLKCTRL_MCLKCTRLB, 0); // 20 MHz
    for (uint16_t n=0; n<256;n++){
       dds[n]=127+127.0*sin(3.1415*n/128.0);
    }
    PORTA.DIR |= PIN3_bm;
    VREF.CTRLA = VREF_DAC0REFSEL_2V5_gc;
    DAC0.CTRLA  = DAC_OUTEN_bm|DAC_ENABLE_bm; 
    DAC0.DATA  = 0;  //DA an PA6
    TCA0.SINGLE.CTRLA = TCA_SINGLE_CLKSEL_DIV1_gc; 
    TCA0.SINGLE.PER = 305; //65,536 kHz 
    TCA0.SINGLE.INTCTRL = TCA_SINGLE_OVF_bm;
    TCA0.SINGLE.CTRLA |= TCA_SINGLE_ENABLE_bm;
    while (1) {
    }
}